import pathlib
import subprocess

def gen_image_cache():
    luclient = pathlib.Path('./archive.org/')
    files = [path for path in luclient.rglob("*.dds") if path.is_file()]
    print(f"Got {len(files)} dds files")
    for file in files:
        try:
            file.parent.mkdir(parents=True, exist_ok=True)
            if file.with_suffix('.png').is_file():
                print(f"{str(file.with_suffix('.png').as_posix()).lower()} already exists, skipping")
                continue
            print(f"Convert {file.as_posix()} to {str(file.with_suffix('.png').as_posix()).lower()}")
            subprocess.Popen(f"convert \"{file.as_posix()}\" \"{file.with_suffix('.png').as_posix()}\"", shell=True, stdin=None, stdout=None, stderr=None, close_fds=True)

        except Exception as e:
            print(f"Error on {file}:\n {e}\n\n Skipping")
    print(f"Converted {len(files)} files")

print("Start")
# do the thing
gen_image_cache()
print("End")
